using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Text;

using Westwind.Web.Data;

namespace DataBindingSample
{
	/// <summary>
	/// Summary description for ClassPropertyBinding.
	/// </summary>
	public class ClassPropertyBinding : System.Web.UI.Page
	{
		protected Westwind.Web.Data.wwWebTextBox txtCompany;
		protected Westwind.Web.Data.wwWebTextBox txtName;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected System.Web.UI.WebControls.Label lblMessage;
		protected Westwind.Web.Data.wwWebTextBox txtInvTotal;
		protected Westwind.Web.Data.wwWebTextBox txtInvDate;
		protected System.Web.UI.WebControls.Button Button2;
		protected Westwind.Web.Data.wwWebCheckBox WwWebCheckBox1;
	
		protected cCustomer Customer;
		protected Westwind.Web.Data.wwWebTextBox txtCustomMessage;
		protected string CustomMessage = "Form Property Value this.CustomMessage";

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			Customer = new cCustomer();

			if (!this.IsPostBack) 
			{
				// *** Manual Binding for each control
				/* this.txtCompany.BindData(this);
				this.txtName.BindData(this);
				this.txtTotal.BindData(this);
				this.txtShipped.BindData(this);
				*/

				wwWebDataHelper.FormBindData(this);
			}
			else 
			{
				// *** Manual Unbinding for each control 
				/*
				this.txtCompany.UnbindData(this);
				this.txtName.UnbindData(this);
				*/

				// *** Automatic unbinding
				BindingError[] Errors = wwWebDataHelper.FormUnbindData(this);
				
				// *** Optional Error Parsing
				if (Errors != null) 
				{
					string lcErrors = "";
					for (int x = 0; x < Errors.Length; x++) 
					{
						lcErrors = lcErrors + Errors[x].Message + "<br>";
					}
					if (!wwUtils.Empty(lcErrors))
						this.lblMessage.Text = "<b>Data unbinding Errors:</b><br>" + lcErrors + "<P>";
				}
				
				
				// *** Dumping output to see content of object
				// *** via XML Serialization
				XmlTextWriter writer = null;
				
				XmlSerializer serializer = 
						new XmlSerializer(typeof(cCustomer));

				// Create an XmlTextWriter using a FileStream.
				StringWriter sb = new StringWriter();
				writer = new XmlTextWriter(sb);

				writer.Formatting = Formatting.Indented;
				writer.IndentChar = ' ';
				writer.Indentation = 4;
				
				// Serialize using the XmlTextWriter.
				serializer.Serialize(writer,this.Customer);
				writer.Close();

				// *** Show data was back bound to the object
				string ObjXml = sb.ToString();

				// *** Display errors and XML object
				this.lblMessage.Text = this.lblMessage.Text + 
						"<b>Customer Object after save:</b><hr><pre>" + 
						wwUtils.FixHTMLForDisplay(ObjXml) + "</pre>" + 
					    "<p><b>Custom Message Form Property:</b> " + this.CustomMessage;
			}
		}
	}

	/// <summary>
	/// Sample Customer class for property/field binding
	/// </summary>
	public class cCustomer : MarshalByRefObject 
	{
		public string Company 
		{
			get {return this.cCompany;}
			set { this.cCompany = value;}
		}	
		string cCompany =  "West Wind Technologies";

		public string Name = "Rick Strahl";
		public decimal InvTotal = 123.44M;
		public DateTime InvDate = DateTime.Now;
		public bool Shipped = true;
	}

}
