using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Westwind.Web.Data;

namespace DataBindingSample
{
	/// <summary>
	/// Summary description for ProductList_Data.
	/// </summary>
	public class ProductList_Data : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList txtSearchSku;
		protected Westwind.Web.Data.wwWebTextBox txtDescript;
		protected Westwind.Web.Data.wwWebTextBox txtlDescript;
		protected Westwind.Web.Data.wwWebTextBox txtPrice;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.Label txtErrorMessage;
		protected Westwind.Web.Data.wwWebTextBox txtSku;

		public busInventory Inventory;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected Westwind.Web.Data.wwWebTextBox Wwwebtextbox1;
		protected Westwind.Web.Data.wwWebCheckBox txtPhysical;
		protected Westwind.Web.Data.wwWebCheckBox txtNoWeb;
		protected Westwind.Web.Data.wwWebTextBox WwWebTextBox2;
		public DataTable InvTable;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

			if (!this.IsPostBack) 
			{
				Inventory = new busInventory();

				// *** Get Item list into a table TItemList
				Inventory.GetItemList("sku,descript");

				this.txtSearchSku.DataSource = Inventory.DataSet.Tables["TItemList"];
				this.txtSearchSku.DataBind();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			string Sku = this.txtSearchSku.SelectedValue;
			if (Sku == null || Sku.Length < 1)  
			{
				this.ShowErrorMessage("Invalid Sku selected...");
				return;
			}

			Inventory = new busInventory();
	
			// *** Load the item - will load Item.DataSet and Item.DataRow
			if ( !Inventory.LoadBySku(Sku)  )
			{
				this.ShowErrorMessage(Inventory.ErrorMsg);
				return;
			}

			// Save the current Sku so we can retrieve it
			// later when we save
			ViewState.Add("Sku",Sku);  

			InvTable = Inventory.DataSet.Tables["wws_items_Record"];

			// *** Now bind to data
			wwWebDataHelper.FormBindData(this);
		}


		public void ShowErrorMessage(string ErrorMessage) 
		{
			this.txtErrorMessage.Text = ErrorMessage;
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			Inventory = new busInventory();

			string Sku =(string)  ViewState["Sku"];
			if (Sku == null) 
			{
				this.ShowErrorMessage("Can't save this item - invalid Sku");
				return;
			}

			// Load the existing item
			// Creates Inventory.DataRow member that the form is bound to
			Inventory.LoadBySku(Sku);

			this.InvTable = Inventory.DataSet.Tables["wws_items_Record"];

			// Now Update the bound fields (DataRow) from the form
			BindingError[] Errors =  wwWebDataHelper.FormUnbindData(this);
			if (Errors != null) 
			{
				this.ShowErrorMessage( wwWebDataHelper.BindingErrorsToHtml(Errors) );
				return;
			}

			if (!Inventory.Save()) 
			{
				this.ShowErrorMessage(Inventory.ErrorMsg);
				return;
			}

			// *** Rebind with the new values as saved
			wwWebDataHelper.FormBindData(this);

			this.ShowErrorMessage("Inventory Item Saved...");
			//Response.Redirect("Itemlist.aspx");
		}

	
	}
}
