using System;


namespace DataBindingSample
{
	/// <summary>
	/// Simple customer business object that works
	/// against the Nortwind database.
	/// 
	/// NOTE: Add an int PK field to the database and fill the values
	///       for the various read methods to work correctly.
	/// </summary>
	public class busCustomer : SimpleBusObj
	{
		public busCustomer()
		{
			//
			// TODO: Add constructor logic here
			//
			this.ConnectionString = "server=(local);database=WebStore;trusted_connection=true";
			this.TableName = "wws_customers";
			this.PkField = "Pk";
		}

		public bool LoadByCompany(string Company) 
		{
			if (this.Execute("select * from " + this.TableName + " where Company like '" + Company + "'",this.TableName + "_Record") < 1) 
				return false;

			this.DataRow = this.DataSet.Tables[this.TableName + "_Record"].Rows[0];
			
			return true;
		}

		public int GetCustomerList(string CursorName) 
		{
			
			if (CursorName == null)
				CursorName = "TCustomers";

			return this.Execute("select Company,pk from  " +this.TableName + " order by Company",CursorName);	
		}


	}

	
}
