using System.Data;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Reflection;

namespace Westwind.Web.Data
{
	/// <summary>
	/// Summary description for wwWebTextBox.
	/// </summary>
	/// 	
	[ToolboxBitmap(typeof(CheckBox)),
	DefaultProperty("Checked"),
	ToolboxData("<{0}:wwWebCheckBox runat='server' size='20'></{0}:wwWebCheckBox>")]
	public class wwWebCheckBox : System.Web.UI.WebControls.CheckBox,IwwWebDataControl
	{

		#region IwwWebDataControl Property Implementation

		/// <summary>
		/// The object that is to be bound to
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingSourceObject
		{
			get { return this.cBindingSourceObject; }
			set { this.cBindingSourceObject = value; }
		}
		string cBindingSourceObject = "";

		/// <summary>
		/// The property that is to be bound to
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingSourceProperty
		{
			get { return this.cBindingSourceProperty; }
			set { this.cBindingSourceProperty = value; }
		}
		string cBindingSourceProperty = "";
		
		/// <summary>
		/// The property that is set by the databinding.
		/// </summary>
		[Category("Data"),
		DefaultValue("Checked")]
		public string BindingProperty
		{
			get { return this.cBindingProperty; }
			set { this.cBindingProperty = value; }
		}
		string cBindingProperty = "Checked";

		/// <summary>
		/// Error message set when a data unbinding error occurs.
		/// Optional - Default message: 'Invalid Data Format for 'control name'
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingErrorMessage
		{
			get { return this.cBindingErrorMessage; }
			set { this.cBindingErrorMessage = value; }
		}
		string cBindingErrorMessage;

		/// <summary>
		/// The Format string used when displaying this data
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string DisplayFormat
		{
			get { return this.cDisplayFormat; }
			set { this.cDisplayFormat = value; }
		}
		string cDisplayFormat = "";

		
		/// <summary>
		/// The format string used to format this field when binding. Defaults to fieldname with txtStripped.
		/// </summary>
		[Category("Data"),
		Description("The format string used to format this field when binding. Defaults to fieldname with txtStripped."),
		DefaultValue("")]
		public string UserFieldName 
		{
			get 
			{
				if (this.cUserFieldName == "") 
					this.UserFieldName = this.ID.Replace("txt","");
				return this.cUserFieldName; 
			}
			set {this.cUserFieldName = value;}
		}
		string cUserFieldName = "";
		
		#endregion

		#region IwwWebDataControl Method implementation

		public wwWebCheckBox()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		/// Binds the control to the control BindingSource.
		/// </summary>
		/// <param name="WebForm">Pass in the WebForm that contains the control source</param>
		public void BindData(Page WebForm) 
		{
			
			wwWebDataHelper.ControlBindData(WebForm,this);
		}

		/// <summary>
		/// Unbinds the control from the BindingSource by loading the BindingSource with the value in the control.
		/// </summary>
		/// <param name="WebForm">The WebPage that contains the control source</param>
		public void UnbindData(Page WebForm) 
		{
			wwWebDataHelper.ControlUnbindData(WebForm,this);
		}
		#endregion

		/// <summary>
		/// Override this method to provide error information
		/// </summary>
		/// <param name="writer"></param>
		protected override void Render(HtmlTextWriter writer)
		{
			base.Render (writer);

			if (this.BindingErrorMessage != null && this.BindingErrorMessage != "" ) 
			{
				writer.Write(" <img src='images/warning.gif' alt='" + this.BindingErrorMessage + "' onClick='alert(\"" + this.BindingErrorMessage + "\")'>");
			}

		}

	}
}
