using System;
using System.Data;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace Westwind.Web.Data
{
	/// <summary>
	/// Summary description for wwWebTextBox.
	/// </summary>
	/// 	
	[ToolboxBitmap(typeof(RadioButtonList)),
	DefaultProperty("SelectedValue"),
	ToolboxData("<{0}:wwWebRadioButtonList runat='server' size='20'></{0}:wwWebRadioButtonList>")]
	public class wwWebRadioButtonList : System.Web.UI.WebControls.RadioButtonList,IwwWebDataControl
	{
		

		override protected void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			/// *** Handle auto-assigning of SelectedValue
			/// *** so we don't need viewstate to make this happen
			if (!this.EnableViewState && this.Page.IsPostBack) 
			{
				string lcValue = this.Page.Request.Form[this.ID];
				if (lcValue != null)
					this.SelectedValue = lcValue;
			}
		}

		public wwWebRadioButtonList()
		{
			this.RepeatDirection = RepeatDirection.Horizontal;
		}
		
		#region IwwWebDataControl Property Implementation
		/// <summary>
		/// The object that is to be bound to
		/// </summary>
		
		[Category("Data"),
		DefaultValue("")]
		public string BindingSourceObject
		{
			get { return this.cBindingSourceObject; }
			set { this.cBindingSourceObject = value; }
		}
		string cBindingSourceObject = "";

		/// <summary>
		/// The property that is to be bound to
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingSourceProperty
		{
			get { return this.cBindingSourceProperty; }
			set { this.cBindingSourceProperty = value; }
		}
		string cBindingSourceProperty = "";
		
		/// <summary>
		/// The property that is set by the databinding.
		/// </summary>
		[Category("Data"),
		DefaultValue("SelectedValue")]
		public string BindingProperty
		{
			get { return this.cBindingProperty; }
			set { this.cBindingProperty = value; }
		}
		string cBindingProperty = "SelectedValue";

		/// <summary>
		/// The format string used to format this field when binding. Defaults to fieldname with txtStripped.
		/// </summary>
		[Category("Data"),
		Description("The format string used to format this field when binding. Defaults to fieldname with txtStripped."),
		DefaultValue("")]
		public string UserFieldName 
		{
			get 
			{
				if (this.cUserFieldName == String.Empty) 
					this.UserFieldName = this.ID.Replace("txt","");
				return this.cUserFieldName; 
			}
			set {this.cUserFieldName = value;}
		}
		string cUserFieldName = "";

		/// <summary>
		/// Error message set when a data unbinding error occurs.
		/// Optional - Default message: 'Invalid Data Format for 'control name'
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingErrorMessage
		{
			get { return this.cBindingErrorMessage; }
			set { this.cBindingErrorMessage = value; }
		}
		string cBindingErrorMessage;

		/// <summary>
		/// The Format string used when displaying this data
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string DisplayFormat
		{
			get { return this.cDisplayFormat; }
			set { this.cDisplayFormat = value; }
		}
		string cDisplayFormat = "";

		public string Text
		{
			get {return this.SelectedValue;}
			set {this.SelectedValue=value;}
		}


		#endregion

		#region IwwWebDataControl Method Implementation


		/// <summary>
		/// Binds the control to the control BindingSource.
		/// </summary>
		/// <param name="WebForm">Pass in the WebForm that contains the control source</param>
		public void BindData(Page WebForm) 
		{
			wwWebDataHelper.ControlBindData(WebForm,this);
		}

		/// <summary>
		/// Unbinds the control from the BindingSource by loading the BindingSource with the value in the control.
		/// </summary>
		/// <param name="WebForm">The WebPage that contains the control source</param>
		public void UnbindData(Page WebForm) 
		{
			wwWebDataHelper.ControlUnbindData(WebForm,this);
		}

		#endregion
	}
}
