using System;
using System.Data;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Reflection;

namespace Westwind.Web.Data
{

	/// <summary>
	/// Summary description for wwWebTextBox.
	/// </summary>
	/// 	
	[ToolboxBitmap(typeof(TextBox)),
	DefaultProperty("Text"),
	ToolboxData("<{0}:wwWebTextBox runat='server' size='20'></{0}:wwWebTextBox>")]
	public class wwWebTextBox : System.Web.UI.WebControls.TextBox,IwwWebDataControl
	{


		/// <summary>
		/// Override OnLoad to handle displaying password characters from
		/// preloaded data (ASP.Net doesn't display Text in passwords)
		/// </summary>
		/// <param name="e"></param>
override protected void OnLoad(EventArgs e) 
{
	base.OnLoad(e);

	// *** Post back password values as well - you can always clear it manually
	if (this.TextMode ==  TextBoxMode.Password)
		this.Attributes.Add("value", this.Text);

}


		#region IwwWebDataControl Property Implementation

		//		[Category("Data"),
		//		Description("The full object name for the object to bind to. For example: "]
		//		DefaultValue("")]
		//		public string BindingSource
		//		{
		//			get { return this.cBindingSource; }
		//			set 
		//			{ 
		//				this.cBindingSource = value;
		//				
		//				// *** Assign BindingSource Object and BindingSourceProperty
		//				// *** Left most . is object other is property
		//				lnAt = this.cBindingSource.IndexOf(".",0,1);
		//				if (lnAt < 1)
		//					return;
		//
		//
		//			
		//			}
		//		}
		//		string cBindingSource;


		/// <summary>
		/// The object that is to be bound to. This object can be any object, including a 
		/// DataSet, DataRow, DataView, a plain property - anything. The type of object 
		/// determines what the DataSourceProperty value is set to
		/// </summary>
		[Category("Data"),
		Description("The object that the control is bound to (DsCustomers or Customer.DataRow or Customer)"),
		DefaultValue("")]
		public string BindingSourceObject
		{
			get { return this.cBindingSourceObject; }
			set { this.cBindingSourceObject = value; }
		}
		string cBindingSourceObject = "";

		/// <summary>
		/// The property that is to be bound to.
		/// </summary>
		[Category("Data"),
		Description("The property of the object that the control is bound to ("),
		DefaultValue("")]
		public string BindingSourceProperty
		{
			get { return this.cBindingSourceProperty; }
			set { this.cBindingSourceProperty = value; }
		}
		string cBindingSourceProperty = "";

		/// <summary>
		/// The property that is set by the databinding.
		/// </summary>
		[Category("Data"),
		DefaultValue("Text")]
		public string BindingProperty
		{
			get { return this.cBindingProperty; }
			set { this.cBindingProperty = value; }
		}
		string cBindingProperty = "Text";

		/// <summary>
		/// Error message set when a data unbinding error occurs.
		/// Optional - Default message: 'Invalid Data Format for 'control name'
		/// </summary>
		[Category("Data"),
		DefaultValue("")]
		public string BindingErrorMessage
		{
			get { return this.cBindingErrorMessage; }
			set { this.cBindingErrorMessage = value; }
		}
		string cBindingErrorMessage;

		/// <summary>
		/// he format string used to format this field when binding
		/// </summary>
		[Category("Data"),
		Description("The format string used to format this field when binding"),
		DefaultValue("")]
		public string DisplayFormat
		{
			get { return this.cDisplayFormat; }
			set { this.cDisplayFormat = value; }
		}
		string cDisplayFormat = "";

		/// <summary>
		/// The format string used to format this field when binding. Defaults to fieldname with txtStripped.
		/// </summary>
		[Category("Data"),
		Description("The format string used to format this field when binding. Defaults to fieldname with txtStripped."),
		DefaultValue("")]
		public string UserFieldName 
		{
			get 
			{
				if (this.cUserFieldName == String.Empty) 
					this.UserFieldName = this.ID.Replace("txt","");
				return this.cUserFieldName; 
			}
			set {this.cUserFieldName = value;}
		}
		string cUserFieldName = "";

		#endregion

		#region IwwWebDataControl Methods Implementation



		/// <summary>
		/// Binds the control to the control BindingSource.
		/// </summary>
		/// <param name="WebForm">Pass in the WebForm that contains the control source</param>
		public void BindData(Page WebForm) 
		{
			//wwWebDataHelper.ControlBindData(WebForm,this,this.BindingSource,this.BindingProperty);
	
			wwWebDataHelper.ControlBindData(WebForm,this);
		}

		/// <summary>
		/// Unbinds the control from the BindingSource by loading the BindingSource with the value in the control.
		/// </summary>
		/// <param name="WebForm">The WebPage that contains the control source</param>
		public void UnbindData(Page WebForm) 
		{
			wwWebDataHelper.ControlUnbindData(WebForm,this);
		}

		#endregion

		/// <summary>
		/// Override this method to provide error information
		/// </summary>
		/// <param name="writer"></param>
		protected override void Render(HtmlTextWriter writer)
		{
			base.Render (writer);

			if (this.BindingErrorMessage != null && this.BindingErrorMessage != "" ) 
				writer.Write(" <img src='images/warning.gif' alt='" + this.BindingErrorMessage + "')'>");
		}
	}
}
